#!/bin/sh
rm -rf ./board/realtek/rlxboard
rm -rf ./ram_init/*
rm -f ./include/configs/rlxboard.h
rm -f ./include/configs/bspchip.h

if grep ^CONFIG_BOARD_RTS3903=y .config >/dev/null 2>&1; then
	ln -s -r ./board/realtek/rts3903 ./board/realtek/rlxboard;
fi

if grep ^CONFIG_BOARD_RTS3913=y .config >/dev/null 2>&1; then
	ln -s -r ./board/realtek/rts3913 ./board/realtek/rlxboard;
fi

if grep ^CONFIG_BOARD_RTS3915=y .config >/dev/null 2>&1; then
	ln -s -r ./board/realtek/rts3915 ./board/realtek/rlxboard;
fi
ln -s -r ./board/realtek/rlxboard/rlxboard.h ./include/configs/rlxboard.h
ln -s -r ./board/realtek/rlxboard/bspchip.h ./include/configs/bspchip.h

for file in `ls board/realtek/rlxboard/ram_init/`
do
	echo $file
	ln -s -r ./board/realtek/rlxboard/ram_init/$file ./ram_init/$file
done
rm -rf ./ram_init/generate.sh
ln -s -r ./board/realtek/rlxboard/ram_init/generate.sh ./ram_init/generate.sh

rm -rf ./ram_init/ddr3_dq16.bin
rm -rf ./ram_init/ddr3_dq32.bin
if grep ^CONFIG_RTS3915_BGA325_DDR3_GENERAL=y .config >/dev/null 2>&1; then
	ln -s -r ./ram_init/ddr3_EVB_external_dq16.bin \
		./ram_init/ddr3_dq16.bin
	ln -s -r ./ram_init/ddr3_EVB_external_dq32.bin \
		./ram_init/ddr3_dq32.bin
fi

if grep ^CONFIG_RTS3915_BGA325_DDR3_K525=y .config >/dev/null 2>&1; then
	ln -s -r ./ram_init/ddr3_K525_external_dq16.bin \
		./ram_init/ddr3_dq16.bin
	ln -s -r ./ram_init/ddr3_K525_external_dq32.bin \
		./ram_init/ddr3_dq32.bin
fi

if grep ^CONFIG_RTS3915_BGA325_DDR3_K525A1=y .config >/dev/null 2>&1; then
	ln -s -r ./ram_init/ddr3_K525A1_external_dq16.bin \
		./ram_init/ddr3_dq16.bin
	ln -s -r ./ram_init/ddr3_K525A1_external_dq32.bin \
		./ram_init/ddr3_dq32.bin
fi

if grep ^CONFIG_RTS3915_QFN128_DDR3_2GBIT=y .config >/dev/null 2>&1; then
	ln -s -r ./ram_init/ddr3_QFN128_internal_dq16.bin \
		./ram_init/ddr3_dq16.bin
fi


